"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), Object.defineProperty(exports, "default", {
    enumerable: !0,
    get: function() {
        return t;
    }
});
const e = require("@typescript-eslint/utils"), t = (0, require("../util/index.js").createRule)({
    meta: {
        fixable: "code",
        messages: {
            expressionStatement: "Singular expression statement in arrow function can be extracted"
        },
        schema: [],
        type: "problem",
        docs: {
            description: "Hi"
        },
        configurations: {
            recommended: "warn",
            strict: "error"
        }
    },
    defaultOptions: [],
    create: (t)=>{
        let r = (r)=>(n)=>{
                let o = [], s = t.sourceCode.getFirstToken(r.body);
                if (null === s) return null;
                let u = t.sourceCode.getTokenAfter(s);
                if (null === u) return null;
                o.push(n.removeRange([
                    s.range[0],
                    u.range[0]
                ])), o.push(n.insertTextBefore(s, "("));
                let l = t.sourceCode.getLastToken(r.body);
                if (null === l) return null;
                let i = t.sourceCode.getTokenBefore(l);
                return null === i ? null : (o.push(n.removeRange([
                    i.range[0] + 1,
                    l.range[1]
                ])), o.push(n.insertTextAfter(l, ")")), i.type === e.TSESTree.AST_TOKEN_TYPES.Punctuator && ";" === i.value && o.push(n.remove(i)), o);
            };
        return {
            ArrowFunctionExpression: (n)=>{
                if (n.body.type == e.TSESTree.AST_NODE_TYPES.BlockStatement && 1 === n.body.body.length && n.body.body[0].type === e.TSESTree.AST_NODE_TYPES.ExpressionStatement) {
                    let e = t.sourceCode.getFirstToken(n.body);
                    if (null === e) throw Error("Token expected");
                    let o = t.sourceCode.getLastToken(n.body);
                    if (null === o) throw Error("Token expected");
                    let s = {
                        start: e.loc.start,
                        end: o.loc.end
                    };
                    t.report({
                        messageId: "expressionStatement",
                        node: n,
                        loc: s,
                        fix: r(n)
                    });
                    return;
                }
            }
        };
    },
    name: "extract-lone-expressions"
});

//# sourceMappingURL=extract-lone-expressions.js.map