"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), Object.defineProperty(exports, "default", {
    enumerable: !0,
    get: function() {
        return r;
    }
});
const e = require("@typescript-eslint/utils"), r = (0, require("../util/index.js").createRule)({
    name: "no-multiple-array-check",
    meta: {
        messages: {
            arrayEvery: "Move OR and AND conditions on the results of array.every into the callback function",
            arraySome: "Move OR and AND conditions on the results of array.some into the callback function"
        },
        schema: [],
        type: "problem",
        docs: {
            description: "Hi"
        },
        configurations: {
            recommended: "warn",
            strict: "error"
        }
    },
    defaultOptions: [],
    create: (r)=>{
        let t = e.ESLintUtils.getParserServices(r);
        return {
            LogicalExpression: (o)=>{
                let a = [
                    o.left,
                    o.right
                ].map((r)=>{
                    if (r.type === e.AST_NODE_TYPES.CallExpression && r.callee.type === e.AST_NODE_TYPES.MemberExpression) {
                        let e = t.getTypeAtLocation(r.callee.object);
                        if (void 0 === e) return !1;
                        if (e.getSymbol()?.getName() === "Array") {
                            let e = t.getSymbolAtLocation(r.callee);
                            return void 0 !== e && e.getName();
                        }
                    }
                    return !1;
                }).reduce((e, r)=>{
                    switch(typeof e){
                        case "string":
                            return e === r && e;
                        case "boolean":
                            return !1;
                    }
                });
                "some" === a ? r.report({
                    messageId: "arraySome",
                    node: o
                }) : "every" === a && r.report({
                    messageId: "arrayEvery",
                    node: o
                });
            }
        };
    }
});

//# sourceMappingURL=no-multiple-array-check.js.map