"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), Object.defineProperty(exports, "default", {
    enumerable: !0,
    get: function() {
        return r;
    }
});
const e = require("@typescript-eslint/utils"), r = (0, require("../util/index.js").createRule)({
    defaultOptions: [],
    meta: {
        docs: {
            description: "new Promise() can result in unreadable code"
        },
        messages: {
            promiseConstructor: "new Promise() is disallowed syntax"
        },
        schema: [],
        type: "problem",
        configurations: {
            recommended: "warn",
            strict: "error"
        }
    },
    name: "no-new-promise",
    create: (r)=>{
        let t = e.ESLintUtils.getParserServices(r);
        return {
            NewExpression: (e)=>{
                "PromiseConstructor" === t.getTypeAtLocation(e.callee).symbol.escapedName.toString() && r.report({
                    messageId: "promiseConstructor",
                    node: e.callee
                });
            }
        };
    }
});

//# sourceMappingURL=no-new-promise.js.map