"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), Object.defineProperty(exports, "default", {
    enumerable: !0,
    get: function() {
        return n;
    }
});
const e = require("@typescript-eslint/utils"), t = require("typescript"), r = require("@typescript-eslint/utils/eslint-utils");
function a(e) {
    return "string" == typeof e ? e : e.map((e)=>(0, t.isJSDocLinkLike)(e) && e.name ? function(e) {
            let r = "", a = e;
            for(; a;){
                if ((0, t.isQualifiedName)(a) || (0, t.isJSDocMemberName)(a)) {
                    r = "" === r ? a.right.text : `${a.right.text}#${r}`, a = a.left;
                    continue;
                }
                if ((0, t.isIdentifier)(a)) {
                    if ("" === r) return a.text;
                    r = `${a.text}#${r}`, a = void 0;
                    continue;
                }
                break;
            }
            return r;
        }(e.name) : e.text).join("");
}
function i(r, i, n, o, s, c) {
    if (o.type === e.AST_NODE_TYPES.Identifier && (o.parent.type === e.AST_NODE_TYPES.CallExpression || o.parent.type === e.AST_NODE_TYPES.NewExpression) && o.parent.callee === o) {
        let e = i.esTreeNodeToTSNodeMap.get(o.parent), s = n.getResolvedSignature(e);
        if (void 0 === s) return;
        let p = s.getDeclaration();
        if (void 0 === p) return;
        for (let i of (0, t.getAllJSDocTags)(p, t.isJSDocDeprecatedTag)){
            if (i.comment) {
                r.report({
                    messageId: "deprecatedSignatureWithReason",
                    node: o,
                    data: {
                        name: c,
                        signature: n.signatureToString(s, e, t.TypeFormatFlags.WriteTypeArgumentsOfSignature),
                        reason: a(i.comment)
                    }
                });
                break;
            }
            r.report({
                messageId: "deprecatedSignature",
                node: o,
                data: {
                    name: c,
                    signature: n.signatureToString(s, e, t.TypeFormatFlags.WriteTypeArgumentsOfSignature)
                }
            });
        }
        return;
    }
    for (let e of s.getDeclarations() ?? [])for (let i of (0, t.getAllJSDocTags)(e, t.isJSDocDeprecatedTag)){
        if (i.comment) {
            r.report({
                messageId: "deprecatedWithReason",
                node: o,
                data: {
                    name: c,
                    reason: a(i.comment)
                }
            });
            return;
        }
        r.report({
            messageId: "deprecated",
            node: o,
            data: {
                name: c
            }
        });
    }
}
const n = (0, require("../util/index.js").createRule)({
    name: "deprecation",
    meta: {
        docs: {
            description: "Disallow usage of deprecated APIs",
            requiresTypeChecking: !0
        },
        configurations: {
            recommended: "warn",
            strict: "error"
        },
        messages: {
            deprecated: "'{{name}}' is deprecated.",
            deprecatedWithReason: "'{{name}}' is deprecated: {{reason}}",
            deprecatedSignature: "The signature '{{signature}}' of '{{name}}' is deprecated.",
            deprecatedSignatureWithReason: "The signature '{{signature}}' of '{{name}}' is deprecated: {{reason}}"
        },
        schema: [],
        type: "problem"
    },
    defaultOptions: [],
    create (a) {
        let n = (0, r.getParserServices)(a), o = n.program.getTypeChecker();
        return {
            Property (r) {
                let s = n.esTreeNodeToTSNodeMap.get(r);
                if (r.key.type === e.AST_NODE_TYPES.Identifier && (0, t.isShorthandPropertyAssignment)(s)) {
                    let e = o.getTypeAtLocation(s.name).getSymbol();
                    if (void 0 === e) return;
                    i(a, n, o, r, e, r.key.name);
                }
            },
            Identifier (t) {
                if (function(t) {
                    switch(t.parent.type){
                        case e.AST_NODE_TYPES.FunctionDeclaration:
                        case e.AST_NODE_TYPES.TSDeclareFunction:
                        case e.AST_NODE_TYPES.ClassDeclaration:
                        case e.AST_NODE_TYPES.TSInterfaceDeclaration:
                        case e.AST_NODE_TYPES.TSTypeAliasDeclaration:
                        case e.AST_NODE_TYPES.Property:
                            return !0;
                        case e.AST_NODE_TYPES.VariableDeclarator:
                            return t.parent.init !== t;
                        case e.AST_NODE_TYPES.TSPropertySignature:
                        case e.AST_NODE_TYPES.PropertyDefinition:
                            return t.parent.key === t;
                    }
                    return !1;
                }(t)) return;
                let r = n.getSymbolAtLocation(t);
                if (void 0 !== r) try {
                    i(a, n, o, t, r, t.name);
                } catch  {
                    return;
                }
            },
            MemberExpression (t) {
                if (t.property.type === e.AST_NODE_TYPES.PrivateIdentifier) {
                    let e = t.property, r = n.getSymbolAtLocation(e);
                    if (void 0 !== r) try {
                        i(a, n, o, e, r, `#${e.name}`);
                    } catch  {
                        return;
                    }
                }
            }
        };
    }
});

//# sourceMappingURL=deprecation.js.map