"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), Object.defineProperty(exports, "default", {
    enumerable: !0,
    get: function() {
        return e;
    }
});
const e = (0, require("../util/index.js").createRule)({
    meta: {
        messages: {
            anonymous: "Do not use anonymous classes, always give them a formal name"
        },
        schema: [],
        type: "problem",
        configurations: {
            recommended: "error",
            strict: "error"
        }
    },
    defaultOptions: [],
    name: "no-anonymous-classes",
    create: (e)=>({
            ClassExpression: (s)=>{
                null === s.id && e.report({
                    messageId: "anonymous",
                    node: s
                });
            }
        })
});

//# sourceMappingURL=no-anonymous-classes.js.map