"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), Object.defineProperty(exports, "default", {
    enumerable: !0,
    get: function() {
        return t;
    }
});
const e = require("@typescript-eslint/utils"), t = (0, require("../util/index.js").createRule)({
    name: "no-relative-imports",
    meta: {
        messages: {
            declaration: "Do not use relative imports to import from parent directories, always use absolute paths",
            expression: "Do not use relative imports to import from parent directories, always use absolute paths"
        },
        schema: [
            {
                type: "object",
                properties: {
                    allowParentImports: {
                        type: "boolean",
                        description: "Allow ../ relative imports"
                    }
                },
                additionalProperties: !1
            }
        ],
        type: "problem",
        docs: {
            description: "Hi"
        },
        configurations: {
            recommended: "warn",
            strict: "error"
        }
    },
    create: (t)=>{
        let r = !1;
        t.options.length >= 1 && (r = t.options[0].allowParentImports);
        let o = (e, o, s)=>{
            e.startsWith("..") && !r && t.report({
                node: o,
                messageId: s
            });
        };
        return {
            ImportDeclaration: (e)=>{
                o(e.source.value, e.source, "declaration");
            },
            ImportExpression: (t)=>{
                t.source.type === e.AST_NODE_TYPES.Literal && "string" == typeof t.source.value && o(t.source.value, t.source, "expression");
            }
        };
    },
    defaultOptions: [
        {
            allowParentImports: !0
        }
    ]
});

//# sourceMappingURL=no-relative-imports.js.map